FAIL_LOAD="abitest-fp32-fp64 abitest-fp32-fpsingle abitest-fp32-fpsoft \
           abitest-fp64a-fpsingle abitest-fp64a-fpsoft abitest-fp64-fp32 \
           abitest-fp64-fpsingle abitest-fp64-fpsoft abitest-fpsingle-fp32 \
           abitest-fpsingle-fp64 abitest-fpsingle-fp64a abitest-fpsingle-fpsoft \
           abitest-fpsingle-fpxx abitest-fpsingle-fpxxo abitest-fpsoft-fp32 \
           abitest-fpsoft-fp64 abitest-fpsoft-fp64a abitest-fpsoft-fpsingle \
           abitest-fpsoft-fpxx abitest-fpsoft-fpxxo abitest-fpxx-fpsingle \
           abitest-fpxx-fpsoft abitest-fpxxo-fpsingle abitest-fpxxo-fpsoft \
           abitest-fp32-fpcorrupt abitest-fp64a-fpcorrupt abitest-fp64-fpcorrupt \
           abitest-fpany-fpcorrupt abitest-fpcorrupt-fp32 abitest-fpcorrupt-fp64 \
           abitest-fpcorrupt-fp64a abitest-fpcorrupt-fpany abitest-fpcorrupt-fpcorrupt \
           abitest-fpcorrupt-fpext abitest-fpcorrupt-fpnone abitest-fpcorrupt-fpsingle \
           abitest-fpcorrupt-fpsoft abitest-fpcorrupt-fpxx abitest-fpcorrupt-fpxxo \
           abitest-fpext-fpcorrupt abitest-fpnone-fpcorrupt abitest-fpsingle-fpcorrupt \
           abitest-fpsoft-fpcorrupt abitest-fpxx-fpcorrupt abitest-fpxxo-fpcorrupt \
           abitest-fp64-fpnone abitest-fpnone-fp64 abitest-fp32-fpext \
	   abitest-fp64a-fpext abitest-fp64-fpext abitest-fpext-fp32 \
	   abitest-fpext-fp64  abitest-fpext-fp64a abitest-fpext-fpnone \
	   abitest-fpext-fpsingle abitest-fpext-fpsoft abitest-fpext-fpxx \
	   abitest-fpext-fpxxo abitest-fpnone-fpext abitest-fpsingle-fpext \
	   abitest-fpsoft-fpext abitest-fpany-fpext abitest-fpext-fpany \
	   abitest-fpext-fpext abitest-fpxx-fpext abitest-fpxxo-fpext"

REQUIRE_FR0="abitest-fp32-fp32 abitest-fp32-fpany abitest-fp32-fpxx \
             abitest-fp32-fpxxo abitest-fpany-fp32 abitest-fpxx-fp32 \
             abitest-fpxxo-fp32 abitest-fp32-fpnone abitest-fpany-fpnone \
             abitest-fpnone-fp32 abitest-fpnone-fpany abitest-fpnone-fpnone \
             abitest-fpnone-fpxx abitest-fpnone-fpxxo abitest-fpxx-fpnone \
             abitest-fpxxo-fpnone"

UNIVERSAL="abitest-fpany-fpany abitest-fpany-fpxx abitest-fpany-fpxxo \
           abitest-fpsingle-fpany abitest-fpsingle-fpsingle abitest-fpsoft-fpany \
           abitest-fpsoft-fpsoft abitest-fpxx-fpany abitest-fpxx-fpxx \
           abitest-fpxx-fpxxo abitest-fpxxo-fpany abitest-fpxxo-fpxx \
           abitest-fpxxo-fpxxo abitest-fpany-fpsingle abitest-fpany-fpsoft \
	   abitest-fpnone-fpsingle abitest-fpsingle-fpnone
           abitest-fpnone-fpsoft abitest-fpsoft-fpnone"

REQUIRE_FR1="abitest-fp64a-fp64 abitest-fp64a-fp64a abitest-fp64a-fpany \
             abitest-fp64a-fpxx abitest-fp64a-fpxxo abitest-fp64-fp64 \
             abitest-fp64-fp64a abitest-fp64-fpany abitest-fp64-fpxx \
             abitest-fp64-fpxxo abitest-fpany-fp64 abitest-fpany-fp64a \
             abitest-fpxx-fp64 abitest-fpxx-fp64a abitest-fpxxo-fp64 \
             abitest-fpxxo-fp64a"

REQUIRE_FRE="abitest-fp32-fp64a abitest-fp64a-fp32 abitest-fpnone-fp64a \
             abitest-fp64a-fpnone"

PASSING_TESTS="$REQUIRE_FR0 $UNIVERSAL $REQUIRE_FR1 $REQUIRE_FRE"

FP_ABIS="fp32 fpext fpnone fpcorrupt fpsoft fpsingle fp64 fp64a fpxx fpxxo"
CPU=
fail=0
core_supports_r6=0
core_supports_fr1=0
core_supports_fre=0
ldso_has_prctl=1
#"mips32r5-generic-fre"

if [ $1 == "r5sim"  ]; then
#  echo "mips32r5-generic-fr0"
#  ./$0 cpu=mips32r5-generic-fr0 $2
#  if [ $? -ne 0 ]; then
#    fail=1
#  fi
  echo "mips32r5-generic"
  ./$0 cpu=mips32r5-generic fr1 $2
  if [ $? -ne 0 ]; then
    fail=1
  fi
#  echo "mips32r5-generic-fre"
#  ./$0 cpu=mips32r5-generic-fre fr1 fre $2
#  if [ $? -ne 0 ]; then
#    fail=1
#  fi
  if [ $fail -eq 1 ]; then
    echo "FAILED"
    exit 1
  fi
  exit 0
elif [ $1 == "r6sim"  ]; then
  if [ "x$2" != "xnoprctl" ]; then
    echo "MIPS32R6-generic"
    ./$0 cpu=MIPS32R6-generic r6 fr1 $2
    if [ $? -ne 0 ]; then
      fail=1
    fi
  fi
  echo "MIPS32R6-generic-fre"
  ./$0 cpu=MIPS32R6-generic-fre r6 fr1 fre $2
  if [ $? -ne 0 ]; then
    fail=1
  fi
  if [ $fail -eq 1 ]; then
    echo "FAILED"
    exit 1
  fi
  exit 0
else
  while [ $# != 0 ]; do
    case $1 in
      cpu=*) CPU=${1##cpu=};;
      r6) core_supports_r6=1; core_supports_fr1=1;;
      fr1) core_supports_fr1=1;;
      fre) core_supports_fre=1;;
      noprctl) ldso_has_prctl=0;;
      *) echo "unknown argument $1"; exit 1;;
    esac
    shift
  done
fi

# Set up the CPU and supported modes
if [ "x$CPU" == "x" ]; then
  SIM=
  export LD_LIBRARY_PATH=.
else
  SIM="/althome/mips/v6/install-qemu-old/bin/qemu-mipsel -cpu $CPU -E LD_LIBRARY_PATH=."
fi

FLAGS=""
if [ $ldso_has_prctl -eq 1 ]; then
  if [ $core_supports_r6 -eq 1 ]; then
    FLAGS="$FLAGS mr6"
  fi
  if [ $core_supports_fr1 -eq 1 ]; then
    FLAGS="$FLAGS mfr1"
  fi
  if [ $core_supports_fre -eq 1 ]; then
    FLAGS="$FLAGS mfre"
  fi
else
  FLAGS="$FLAGS mno-prctl"
fi
testcount=0

# A test that should be successfully loaded onto the current CPU and
# which should therefore pass regardless of what extra libraries
# are given to it. This is because the test program is designed
# to verify that libraries are correctly loaded or rejected
# appropriately and never fail if the dynamic loader behaves
# correctly.
# This is testing the dynamic loader.

function expect_pass_helper
{
  echo -n "."
  ((testcount++))
  testname=$1
  shift
  $SIM $testname $FLAGS ${@} 2> /dev/null > /dev/null
  exit_code=$?
  if [ $exit_code -ne 0 ]; then
    echo $SIM $testname $FLAGS ${@}
    echo "'$testname ${@}' should work. Received $exit_code"
    fail=1
  fi
}

function expect_pass
{
  for a in $FP_ABIS ; do
    expect_pass_helper $1 $a fpany
    expect_pass_helper $1 fpany $a
  done
  m1list=( fpnone fp32 fpsoft )
  for m1 in ${m1list[@]}; do
    m2list=( ${m1list[@]%%$m1} )
    for m2 in ${m2list[@]}; do
      expect_pass_helper $1 $m1 $m2 ${m2list[@]%%$m2}
    done
  done
  m1list=( fpnone fp32 fpxx fpxxo fp64 fp64a )
  for m1 in ${m1list[@]}; do
    m2list=( ${m1list[@]%%$m1} )
    for m2 in ${m2list[@]}; do
      m3list=( ${m2list[@]%%$m2} )
      for m3 in ${m3list[@]}; do
        m4list=( ${m3list[@]%%$m3} )
        for m4 in ${m4list[@]}; do
          m5list=( ${m4list[@]%%$m4} )
          for m5 in ${m5list[@]}; do
            expect_pass_helper $1 $m1 $m2 $m3 $m4 $m5 ${m5list[@]%%$m5}
          done
        done
      done
    done
  done
}

# A test which is checking that the program loader refuses to load a program
# which cannot possibly execute in any supported hardware mode for the
# current CPU.
# This is testing the program loader

function expect_fail
{
  echo -n "@"
  ((testcount++))
  $SIM $1 $FLAGS 2> /dev/null > /dev/null
  exit_code=$?
  if [ $exit_code -ne 137 ]; then
    echo "'$1' should be rejected by loader with code 137. Received $exit_code"
    fail=1
  fi
}

# This test verifies that the test program raises an error if the program loader
# uses a mode which it does not know is available.
# This is primarily testing the test program and driver.

function expect_inconsistency
{
  echo -n "^"
  ((testcount++))
  # Note the lack of $FLAGS
  $SIM $1 2> /dev/null > /dev/null
  exit_code=$?
  if [ $exit_code -ne 3 ]; then
    echo "'$1' mode check should have failed: kernel should have used $2. Received $exit_code"
    fail=1
  fi
}

for i in $FAIL_LOAD ; do
  expect_fail $i
done

for i in $REQUIRE_FR0 ; do
  if [ $core_supports_r6 -eq 0 ]; then
    expect_pass $i
  elif [ $core_supports_fre -eq 1 ]; then
    # R6 with FRE
    expect_pass $i
    expect_inconsistency $i "FRE"
  else
    # R6 without FRE
    expect_fail $i
  fi
done

for i in $UNIVERSAL ; do
  expect_pass $i
done

for i in $REQUIRE_FR1 ; do
  if [ $core_supports_fr1 -eq 1 -a $ldso_has_prctl -eq 1 ]; then
    # R6 or R<6 with FR1
    expect_pass $i
    expect_inconsistency $i "FR1"
  else
    # No FR1 support
    expect_fail $i
  fi
done

for i in $REQUIRE_FRE ; do
  if [ $core_supports_fre -eq 1 -a $ldso_has_prctl -eq 1 ]; then
    # FRE support
    expect_pass $i
    expect_inconsistency $i "FRE"
  else
    # No FRE support
    expect_fail $i
  fi
done

echo ""
echo "testcount: $testcount"
exit $fail
